<template>
  <v-main class="mainStyle">
    <div class="d-flex">
      <v-card class="ticketCard">
        <div class="m-3 ">
          <div class="d-flex flex-row justify-space-between">
            <h3>Ticket ID: {{ticket.ticketId}}</h3>
            <v-icon v-show="ticket.ticketStatus === 'PROBLEM'" color="red-accent-4">mdi-alert</v-icon>
            <v-icon v-show="ticket.ticketStatus === 'OPEN'" color="green-darken-3">mdi-circle</v-icon>
            <v-icon v-show="ticket.ticketStatus === 'PENDING'" color="yellow-darken-3">mdi-octagon</v-icon>
            <v-icon v-show="ticket.ticketStatus === 'RESOLVED'" color="blue-darken-4">mdi-check-circle</v-icon>
          </div>
          <v-divider></v-divider>
          <p>Aufgabe: <span><strong>{{ticket.title}}</strong></span></p>
          <p>Beschreibung: <span><strong>{{ticket.description}}</strong></span></p>
          <v-divider></v-divider>

          <p><i>Erstellt am: <strong>{{ticket.createdAt}}</strong></i></p>
          <p v-show="ticket.resolvedAt"><i>Erledigt am: <strong>{{ticket.resolvedAt}}</strong></i></p>
          <p><i>Zuständige Abteilung: <strong>{{ticket.department}}</strong></i></p>
          <p><i>Erstellt von: <strong>{{ticket.createdBy}}</strong></i></p>
          <div v-if="ticket.fileName">
            <p><i>File: <strong>{{ticket.fileName}}</strong></i></p>
            <p><i>Download File: <a :href="'http://localhost:8080/api/files/' + ticket.fileName"><strong>hier</strong></a></i></p>

            <img
                v-if="isImageFile"
                style="width: 500px;"
                :src="'http://localhost:8080/api/files/' + ticket.fileName">
          </div>

          <p v-if="ticket.ticketStatus === 'RESOLVED'"><i>Erledigt von: <strong>{{ticket.resolvedBy}}</strong></i></p>
          <p v-if="ticket.ticketStatus !== 'RESOLVED' && ticket.resolvedBy"><i>Zuletzt bearbeitet von: <strong>{{ticket.resolvedBy}}</strong></i></p>

          <v-divider></v-divider>
          <div v-if="ticket.resolvedBy === authStore.user.username">
            <p>Anhang: (Optional)</p>
            <file-upload @file-uploaded="handleFileUpload"></file-upload>
            <v-btn color="blue-darken-4" @click="submitFileUpload">Bestätigen</v-btn>
          </div>


          <v-divider></v-divider>
          <div v-if="ticket.comment?.length > 0">
            <p ><i>Kommentar: <strong>{{ticket.comment}}</strong></i></p>
          </div>
          <v-form v-if="ticket.resolvedBy === authStore.user.username || ticket.createdBy === authStore.user.username" @submit.prevent="handleSubmit">
            <v-text-field
                v-model="comment.commentText"
                label="Kommentar"
                type="text"
                counter="255"
            ></v-text-field>
            <v-btn color="blue-darken-4" type="submit">Kommentar hinzufügen</v-btn>
          </v-form>
        </div>

      </v-card>
      <div class="ms-2">
        <v-card class="d-flex flex-column actionsCard">
          <h2 class="m-3">Aktionen</h2>
          <v-divider></v-divider>
          <v-btn
              class="m-2"
              v-show="ticket.department === authStore.user.department"
              :disabled="ticket.ticketStatus === 'PENDING'"
              @click.stop="acceptTicket" v-if="ticket.ticketStatus !== 'RESOLVED'"
              color="green-darken-3"><v-icon>mdi-check</v-icon></v-btn>

          <v-btn
              class="m-2"
              color="green-darken-3"
              v-if="authStore.user.username === ticket.resolvedBy && ticket.ticketStatus !== 'RESOLVED'"
              @click="finishTicket">Finish</v-btn>

          <v-btn
              class="m-2"
              color="red-accent-4"
              v-if="authStore.user.username === ticket.resolvedBy && ticket.ticketStatus !== 'RESOLVED'"
              @click="problemTicket">Problem</v-btn>

          <v-btn
              class="m-2"
              color="yellow-darken-3"
              v-if="authStore.user.username === ticket.resolvedBy && ticket.ticketStatus !== 'RESOLVED'"
              @click="returnTicket">Return Ticket</v-btn>

          <v-btn
              color="blue-darken-4"
              class="m-2"
              @click="router.back()">Back</v-btn>
        </v-card>
      </div>

    </div>
  </v-main>

</template>

<script setup>

import {computed, onMounted, ref} from "vue";
import {useTicketStore} from "@/stores/ticketStore";
import {router} from "@/router";
import {useAuthStore} from "@/stores/authStore";
import {useUploadStore} from "@/stores/uploadStore";
import FileUpload from "@/components/FileUpload.vue";


const ticketStore = useTicketStore();
const authStore = useAuthStore();
const uploadStore = useUploadStore();

const emits = defineEmits(['showComponent']);

let fileName = ref(null);
const ticketForFile = ref({
  title: "",
  description: "",
  priority: "",
  department: ""
})
const ticket = computed(() => ticketStore.ticket)
const file = computed(() => uploadStore.file)
const ticketId = router.currentRoute.value.params.id;
const isImageFile = computed(() => {
  if (!ticket.value.fileName) {
    return false;
  }

  const validExtensions = ["png", "jpg", "jpeg", "jfif"];
  const fileExtension = ticket.value.fileName
      .split(".")
      .pop()
      .toLowerCase();

  return validExtensions.includes(fileExtension);
});

const handleFileUpload = (uploadedFileName) => {
  fileName.value = uploadedFileName;
};

async function submitFileUpload() {
  await ticketStore.removeTicketFileRelation(fileName.value);
  if (fileName.value !== null) { //Set relation between file and ticket, if file is uploaded
    await ticketStore.putTicketFileRelation(fileName.value, ticket.value)
    await ticketStore.getTicket(ticketId)
  }
}

const ticketAccepted = ref({
  ticketStatus: "",
  userId: 0
});
const comment = ref({
  commentText: "",
  authorId: 0
});

async function handleSubmit() {
  comment.value.authorId = authStore.user.userId;
  await ticketStore.addComment(ticketId, comment.value)
  await ticketStore.getTicket(ticketId)
  comment.value.commentText = "";
}

async function finishTicket() {
  ticketAccepted.value.ticketStatus = "RESOLVED";
  ticketAccepted.value.userId = authStore.user.userId;
  await ticketStore.finishTicket(ticketId, ticketAccepted.value);
  await router.back();
}

async function problemTicket() {
  ticketAccepted.value.ticketStatus = "PROBLEM";
  ticketAccepted.value.userId = authStore.user.userId;
  await ticketStore.problemTicket(ticketId, ticketAccepted.value);
  await router.back();
}

async function returnTicket() {
  ticketAccepted.value.ticketStatus = "OPEN";
  await ticketStore.returnAcceptedTicket(ticketId, ticketAccepted.value)
  await router.back();
}

async function acceptTicket() {
  try {
    ticketAccepted.value.ticketStatus = "PENDING";
    ticketAccepted.value.userId = authStore.user.userId;
    await ticketStore.acceptTicket(ticketId, ticketAccepted.value)
    await ticketStore.getTicket(ticketId);
  } catch (error) {
    console.log("error", error);
    alert("Etwas ist schief gelaufen.")
  }
}

onMounted(async () => {
  await ticketStore.getTicket(ticketId)
});
</script>

<style scoped>

.ticketCard{
  min-width: 50vw;
  min-height: 50vh;
}

.actionsCard{
  min-width: 20vw;
  min-height: 20vh;
}

.mainStyle{
  margin-top: 6%;
  min-height: 100vh;
}
</style>